function serverCmdSetRound(%client, %i)
{
	if(!%client.isAdmin)
		return;
	
	if(mFloor(%i) !$= %i)
	{
		messageClient(%client, '', "Usage: /setRound <number>");
		return;
	}
	
	$Pref::Server::DeathMatch::RoundLimit = mFloor($Pref::Server::DeathMatch::RoundLimit);
	if($Pref::Server::DeathMatch::RoundLimit == 0 || $Pref::Server::DeathMatch::RoundLimit < -1)
		$Pref::Server::DeathMatch::RoundLimit = -1;
	if($Pref::Server::DeathMatch::RoundLimit == -1)
	{
		messageClient(%client, '', "Map rotation is off. Setting the round will do nothing.");
		return;
	}
	
	for(%aaa = 0; %aaa < $DefaultMinigame.numMembers; %aaa++)
	{
		%member = $DefaultMinigame.member[%aaa];
		if(isObject(%member))
		{
			commandToClient(%member, 'bottomPrint', "", 0, true);
			%camera = %member.camera;
			%camera.setFlyMode();
			%camera.mode = "Observer";
			%member.setControlObject(%camera);
		}
	}
	
	if(%i > $Pref::Server::DeathMatch::RoundLimit)
		%i = $Pref::Server::DeathMatch::RoundLimit;
	
	messageAll('MsgAdminForce', '\c3%1\c2 changed the round to \c3round %2\c2.', %client.getPlayerName(), %i);
	
	cancel($DM::Tick);
	DM_Tick(0);
	$DM::ResetCount = %i - 1;
}

function serverCmdNextRound(%client)
{
	if(!%client.isAdmin)
		return;
	
	messageAll('MsgAdminForce', '\c3%1\c2 skipped the round.', %client.getPlayerName());
	if($DM::ResetCount >= $Pref::Server::DeathMatch::RoundLimit && $Pref::Server::DeathMatch::RoundLimit != -1)
	{
		serverCmdNextMap(%client);
		return;
	}
	
	for(%aaa = 0; %aaa < $DefaultMinigame.numMembers; %aaa++)
	{
		%member = $DefaultMinigame.member[%aaa];
		if(isObject(%member))
		{
			commandToClient(%member, 'bottomPrint', "", 0, true);
			%camera = %member.camera;
			%camera.setFlyMode();
			%camera.mode = "Observer";
			%member.setControlObject(%camera);
		}
	}
	
	cancel($DM::Tick);
	DM_Tick(0);
}

function serverCmdSkipRound(%client)
{
	serverCmdNextRound(%client);
}

function serverCmdSetMap(%client, %i)
{
	if(!%client.isAdmin)
		return;
	
	if(mFloor(%i) !$= %i)
	{
		messageClient(%client, '', "Usage: /setMap <number>");
		return;
	}

	if(%i < 0)
		%i = 0;
	
	if(%i > $DM::numMaps)
		%i = $DM::numMaps;
	
	messageAll('MsgAdminForce', '\c3%1\c2 set the map to \c3%2\c2.', %client.getPlayerName(), DM_getMapName(%i));
	
	for(%aaa = 0; %aaa < $DefaultMinigame.numMembers; %aaa++)
	{
		%member = $DefaultMinigame.member[%aaa];
		if(isObject(%member))
		{
			commandToClient(%member, 'bottomPrint', "", 0, true);
			%camera = %member.camera;
			%camera.setFlyMode();
			%camera.mode = "Observer";
			%member.setControlObject(%camera);
		}
	}
	
	$DM::CurrentMap = %i - 1;
	$DM::BypassTheme = true;
	$DM::BypassSort = true;
	$DM::BypassRandom = true;
	SM_StopSong();
	schedule(3000, 0, DM_NextMap);
}

function serverCmdSetTrack(%client, %i)
{
	serverCmdSetMap(%client, %i);
}

function serverCmdNextMap(%client)
{
	if(!%client.isAdmin)
		return;
	
	messageAll('MsgAdminForce', '\c3%1\c2 skipped to the next map.', %client.getPlayerName());
	
	for(%aaa = 0; %aaa < $DefaultMinigame.numMembers; %aaa++)
	{
		%member = $DefaultMinigame.member[%aaa];
		if(isObject(%member))
		{
			commandToClient(%member, 'bottomPrint', "", 0, true);
			%camera = %member.camera;
			%camera.setFlyMode();
			%camera.mode = "Observer";
			%member.setControlObject(%camera);
		}
	}
	
	$DM::BypassRandom = true;
	SM_StopSong();
	schedule(3000, 0, DM_NextMap);
}

function serverCmdSkipMap(%client)
{
	serverCmdNextMap(%client);
}

function serverCmdNextTrack(%client)
{
	serverCmdNextMap(%client);
}

function serverCmdSkipTrack(%client)
{
	serverCmdNextMap(%client);
}

function serverCmdRandomMap(%client)
{
	if(!%client.isAdmin)
		return;
	
	messageAll('MsgAdminForce', '\c3%1\c2 skipped to a random map.', %client.getPlayerName());
	
	for(%aaa = 0; %aaa < $DefaultMinigame.numMembers; %aaa++)
	{
		%member = $DefaultMinigame.member[%aaa];
		if(isObject(%member))
		{
			commandToClient(%member, 'bottomPrint', "", 0, true);
			%camera = %member.camera;
			%camera.setFlyMode();
			%camera.mode = "Observer";
			%member.setControlObject(%camera);
		}
	}
	
	$DM::ForceRandom = true;
	SM_StopSong();
	schedule(3000, 0, DM_NextMap);
}

function serverCmdRandomTrack(%client)
{
	serverCmdRandomMap(%client);
}

//MAP VOTING COMMANDS
function serverCmdVoteMap(%client, %i)
{
	if($Pref::Server::DeathMatch::EnableMapVoting $= 0)
	{
		messageClient(%client, '', "Map voting is disabled.");
		return;
	}
	
	if(mFloor(%i) !$= %i)
	{
		messageClient(%client, '', "Usage: /vm <number>");
		return;
	}
	
	if($DM::VoteInProgress)
	{
		messageClient(%client, '', "There's already a vote in progress. Type /cv to see what it is and /rtv to rock it.");
		return;
	}
	
	if(%i == $DM::CurrentMap)
	{
		messageClient(%client, '', "You're playing in that map right now.");
		return;
	}
	
	if($Pref::Server::DeathMatch::ForceMapCategory !$= "" && $Pref::Server::DeathMatch::ForceMapTheme !$= "")
	{
		if($DM::MapSort[%i] !$= $Pref::Server::DeathMatch::ForceMapCategory || $DM::MapTheme[%i] !$= $Pref::Server::DeathMatch::ForceMapTheme)
		{
			messageClient(%client, '', "You cannot vote for that map.");
			return;
		}
	}
	else if($Pref::Server::DeathMatch::ForceMapCategory !$= "")
	{
		if($DM::MapSort[%i] !$= $Pref::Server::DeathMatch::ForceMapCategory)
		{
			messageClient(%client, '', "You cannot vote for that map.");
			return;
		}
	}
	else if($Pref::Server::DeathMatch::ForceMapTheme !$= "")
	{
		if($DM::MapTheme[%i] !$= $Pref::Server::DeathMatch::ForceMapTheme)
		{
			messageClient(%client, '', "You cannot vote for that map.");
			return;
		}
	}

	if(mfloor(%i) < 0)
		%i = 0;
	
	if(mfloor(%i) >= $DM::numMaps)
		%i = $DM::numMaps - 1;
	
	echo(%client.getPlayerName() @ " started a vote to change the map to " @ DM_getMapName(mfloor(%i)) @ ".");
	messageAll('MsgAdminForce', '\c3%1\c2 voted to set the map to \c3%2\c2.', %client.getPlayerName(), DM_getMapName(mfloor(%i)));
	messageAll('MsgAdminForce', '\c2Type \c3/rtv\c2 to rock the vote!');
	$DM::VoteInProgress = true;
	$DM::VoteMap = mfloor(%i);
	%client.DM_isRockingVote = true;
	
	if($DefaultMinigame.numMembers == 1)
	{
		echo("Votes resulted in the map changing next round.");
		messageAll('MsgAdminForce', '\c2Enough people rocked the vote that the map will change \c3next round\c2!');
		$DM::VoteNextRound = true;
	}
}

function serverCmdVM(%client, %i)
{
	serverCmdVoteMap(%client, %i);
}

function serverCmdVoteTrack(%client, %i)
{
	serverCmdVoteMap(%client, %i);
}

function serverCmdVT(%client, %i)
{
	serverCmdVoteMap(%client, %i);
}

function serverCmdCurrentVote(%client)
{
	if(!$DM::VoteInProgress)
	{
		messageClient(%client, '', "There's no vote in progress.");
		return;
	}
	
	messageClient(%client, '', "\c6A vote is in progress to set the map to \c3" @ DM_getMapName($DM::VoteMap) @ "\c6.");
	
	if(%client.DM_isRockingVote)
		messageClient(%client, '', "\c6You're rocking the vote right now.");
	else
		messageClient(%client, '', "\c6Type \c3/rtv\c6 to rock the vote!");
}

function serverCmdCV(%client)
{
	serverCmdCurrentVote(%client);
}

function serverCmdRockTheVote(%client)
{
	if(!$DM::VoteInProgress)
	{
		messageClient(%client, '', "There's no vote in progress.");
		return;
	}
	
	if(%client.DM_isRockingVote)
	{
		messageClient(%client, '', "You've already rocked the vote.");
		return;
	}
	
	echo(%client.getPlayerName() @ " rocked the vote.");
	messageAll('MsgAdminForce', '\c3%1\c2 rocked the vote!', %client.getPlayerName());
	%client.DM_isRockingVote = true;
	DM_CheckVotes();
}

function serverCmdRTV(%client)
{
	serverCmdRockTheVote(%client);
}

function DM_CheckVotes()
{
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
		{
			if(%member.DM_isRockingVote)
				%rockers++;
		}
	}
	
	%sub = $DefaultMinigame.numMembers * 0.7;
	if(%rockers >= %sub && $Pref::Server::DeathMatch::EnableMapVoting !$= 2)
	{
		echo("Votes resulted in the map changing immediately.");
		messageAll('MsgAdminForce', '\c2Enough people rocked the vote that the map will change \c3right now\c2!');
		
		for(%aaa = 0; %aaa < $DefaultMinigame.numMembers; %aaa++)
		{
			%member = $DefaultMinigame.member[%aaa];
			if(isObject(%member))
			{
				commandToClient(%member, 'bottomPrint', "", 0, true);
				%camera = %member.camera;
				%camera.setFlyMode();
				%camera.mode = "Observer";
				%member.setControlObject(%camera);
			}
		}
		
		$DM::CurrentMap = $DM::VoteMap - 1;
		$DM::BypassTheme = true;
		$DM::BypassSort = true;
		$DM::BypassRandom = true;
		SM_StopSong();
		schedule(3000, 0, DM_NextMap);
		return;
	}
	
	%subb = $DefaultMinigame.numMembers * 0.4;
	if(%rockers >= %subb && !$DM::VoteNextRound)
	{
		echo("Votes resulted in the map changing next round.");
		messageAll('MsgAdminForce', '\c2Enough people rocked the vote that the map will change \c3next round\c2!');
		$DM::VoteNextRound = true;
		return;
	}
}