if(!$DM::HasExecutedOnce)
{
	//unregistering events we absolutely do not want map makers to use
	unRegisterOutputEvent("gameConnection", "bottomPrint");
	unRegisterOutputEvent("MiniGame", "bottomPrintAll");
	unRegisterOutputEvent("MiniGame", "reset");

	//some useful events for map makers to take avantage of deathmatch gamemode features
	registerOutputEvent("Player", "fall");
	registerOutputEvent("Player", "addArmor", "int -9999 9999 1");
	registerOutputEvent("Player", "setArmor", "int 0 9999 1");
	registerOutputEvent("Player", "setCanCloak", "bool");
	registerOutputEvent("Player", "setSquished", "bool");
}

//event coding
function Player::fall(%this)
{
	%this.hasShotOnce = true;
	%this.invulnerable = false;
	%this.damage(%this, %this.getPosition(), 10000, $DamageType::Fall);
}

function Player::addArmor(%this, %amount)
{
	%this.DM_HealthShield += %amount;
	if(%this.DM_HealthShield < 0)
		%this.DM_HealthShield = 0;
}

function Player::setArmor(%this, %amount)
{
	%this.DM_HealthShield = %amount;
}

function Player::setCanCloak(%this, %bool)
{
	if(%bool)
	{
		%data = %this.getDatablock();
		%model = fileName(%data.shapeFile);
		if(%model !$= "m.dts")
			return;
		
		%this.canCloak = true;
	}
	else
		%this.canCloak = false;
}

function Player::setSquished(%this, %bool)
{
	%height = getWord(%this.getscale(), 2);
	%width = getWord(%this.getscale(), 0);
	
	if(%bool)
		%this.setscale(%width SPC %width SPC (%width * 0.35));
	else
		%this.setscale(%width SPC %width SPC %width);
}