function DM_ConvertOldItem(%item)
{
	if(%item $= "shotgunItem")
		%item = "redShotgunItem";
		
	if(%item $= "SniperRifleItem")
		%item = "blueSniperItem";
		
	if(%item $= "blockheadRayItem")
		%item = "blockheadKitItem";
		
	if(%item $= "blockheadShotgunItem")
		%item = "blockheadKitItem";
	
	return %item;
}

function DM_AddFakeNameTables()
{
	$uiNameTable_Items["Shotgun"]			= "redShotgunItem";
	$uiNameTable_Items["Sniper Rifle"]		= "blueSniperItem";
	$uiNameTable_Items["Blockhead Ray"]		= "blockheadKitItem";
	$uiNameTable_Items["Blockhead Shotgun"]	= "blockheadKitItem";
}

function DM_GetRandomItem()
{
	%a = 0;
	
	//ranged
	%weapon[%a++] = "BowItem";
	%weapon[%a++] = "GunItem";
	%weapon[%a++] = "AkimboGunItem";
	%weapon[%a++] = "rocketLauncherItem";
	%weapon[%a++] = "spearItem";
	%weapon[%a++] = "cannonLauncherItem";
	%weapon[%a++] = "pongGunItem";
	%weapon[%a++] = "TommyGunItem";
	%weapon[%a++] = "SMGItem";
	%weapon[%a++] = "homingRocketLauncherItem";
	%weapon[%a++] = "blueLongbowItem";
	%weapon[%a++] = "blueSniperItem";
	%weapon[%a++] = "blueTranquilizerItem";
	%weapon[%a++] = "greenCrossbowItem";
	%weapon[%a++] = "greenGLauncherItem";
	%weapon[%a++] = "greenMortarItem";
	%weapon[%a++] = "orangeFlamethrowerItem";
	%weapon[%a++] = "redDisintegratorItem";
	%weapon[%a++] = "redMachineGunItem";
	%weapon[%a++] = "redRevolversItem";
	%weapon[%a++] = "redShotgunItem";
	%weapon[%a++] = "AkimboRocketItem";
	%weapon[%a++] = "redRevolverItem";
	%weapon[%a++] = "HandgunBItem";
	%weapon[%a++] = "greenGLaunchersItem";
	%weapon[%a++] = "slowRocketLauncherItem";
	
	//melee
	%weapon[%a++] = "swordItem";
	%weapon[%a++] = "hammerWeaponItem";
	%weapon[%a++] = "wrenchWeaponItem";
	%weapon[%a++] = "printerWeaponItem";
	%weapon[%a++] = "pinballLauncherItem";
	%weapon[%a++] = "chainsawItem";
	%weapon[%a++] = "fistItem";
	%weapon[%a++] = "butterflyknifeItem";
	%weapon[%a++] = "airhammerItem";
	%weapon[%a++] = "crowbarItem";
	%weapon[%a++] = "redBaseballBatItem";
	
	//special
	%weapon[%a++] = "pushBroomItem";
	%weapon[%a++] = "PullerRope";
	%weapon[%a++] = "GrappleRope";
	
	//kits
	if($Pref::Server::DeathMatch::RandomisedKits)
	{
		%weapon[%a++] = "blueCloakItem";
		%weapon[%a++] = "growKitItem";
		%weapon[%a++] = "shrinkKitItem";
		%weapon[%a++] = "healthKitItem";
		%weapon[%a++] = "shieldKitItem";
		%weapon[%a++] = "blockheadKitItem";
		%weapon[%a++] = "bouncyKitItem";
	}
	
	//printer rays
	if($Pref::Server::DeathMatch::RandomisedPrinterRays)
	{
		%weapon[%a++] = "horseRayItem";
		%weapon[%a++] = "chickenRayItem";
		%weapon[%a++] = "ShrinkRayItem";
		%weapon[%a++] = "AntiShrinkRayItem";
	}
	
	//shotgun rays
	if($Pref::Server::DeathMatch::RandomisedShotgunRays)
	{
		%weapon[%a++] = "horseShotgunItem";
		%weapon[%a++] = "chickenShotgunItem";
		%weapon[%a++] = "shrinkShotgunItem";
		%weapon[%a++] = "antiShrinkShotgunItem";
	}
	
	return %weapon[getRandom(1, %a)];
}

function DM_GetRandomWeapon()
{
	%a = 0;
	
	//ranged
	%weapon[%a++] = "BowItem";
	%weapon[%a++] = "GunItem";
	%weapon[%a++] = "AkimboGunItem";
	%weapon[%a++] = "rocketLauncherItem";
	%weapon[%a++] = "spearItem";
	%weapon[%a++] = "cannonLauncherItem";
	%weapon[%a++] = "pongGunItem";
	%weapon[%a++] = "TommyGunItem";
	%weapon[%a++] = "SMGItem";
	%weapon[%a++] = "homingRocketLauncherItem";
	%weapon[%a++] = "blueLongbowItem";
	%weapon[%a++] = "blueSniperItem";
	%weapon[%a++] = "blueTranquilizerItem";
	%weapon[%a++] = "greenCrossbowItem";
	%weapon[%a++] = "greenGLauncherItem";
	%weapon[%a++] = "greenMortarItem";
	%weapon[%a++] = "orangeFlamethrowerItem";
	%weapon[%a++] = "redDisintegratorItem";
	%weapon[%a++] = "redMachineGunItem";
	%weapon[%a++] = "redRevolversItem";
	%weapon[%a++] = "redShotgunItem";
	%weapon[%a++] = "AkimboRocketItem";
	%weapon[%a++] = "redRevolverItem";
	%weapon[%a++] = "HandgunBItem";
	%weapon[%a++] = "greenGLaunchersItem";
	%weapon[%a++] = "slowRocketLauncherItem";
	
	//melee
	%weapon[%a++] = "swordItem";
	%weapon[%a++] = "hammerWeaponItem";
	%weapon[%a++] = "wrenchWeaponItem";
	%weapon[%a++] = "printerWeaponItem";
	%weapon[%a++] = "pinballLauncherItem";
	%weapon[%a++] = "chainsawItem";
	%weapon[%a++] = "fistItem";
	%weapon[%a++] = "butterflyknifeItem";
	%weapon[%a++] = "airhammerItem";
	%weapon[%a++] = "crowbarItem";
	%weapon[%a++] = "redBaseballBatItem";
	
	return %weapon[getRandom(1, %a)];
}

function DM_GetRandomRangedWeapon()
{
	%a = 0;
	
	//ranged
	%weapon[%a++] = "BowItem";
	%weapon[%a++] = "GunItem";
	%weapon[%a++] = "AkimboGunItem";
	%weapon[%a++] = "rocketLauncherItem";
	%weapon[%a++] = "spearItem";
	%weapon[%a++] = "cannonLauncherItem";
	%weapon[%a++] = "pongGunItem";
	%weapon[%a++] = "TommyGunItem";
	%weapon[%a++] = "SMGItem";
	%weapon[%a++] = "homingRocketLauncherItem";
	%weapon[%a++] = "blueLongbowItem";
	%weapon[%a++] = "blueSniperItem";
	%weapon[%a++] = "blueTranquilizerItem";
	%weapon[%a++] = "greenCrossbowItem";
	%weapon[%a++] = "greenGLauncherItem";
	%weapon[%a++] = "greenMortarItem";
	%weapon[%a++] = "orangeFlamethrowerItem";
	%weapon[%a++] = "redDisintegratorItem";
	%weapon[%a++] = "redMachineGunItem";
	%weapon[%a++] = "redRevolversItem";
	%weapon[%a++] = "redShotgunItem";
	%weapon[%a++] = "AkimboRocketItem";
	%weapon[%a++] = "redRevolverItem";
	%weapon[%a++] = "HandgunBItem";
	%weapon[%a++] = "greenGLaunchersItem";
	%weapon[%a++] = "slowRocketLauncherItem";
	
	return %weapon[getRandom(1, %a)];
}

function DM_GetRandomMeleeItem()
{
	%a = 0;
	
	//melee
	%weapon[%a++] = "swordItem";
	%weapon[%a++] = "hammerWeaponItem";
	%weapon[%a++] = "wrenchWeaponItem";
	%weapon[%a++] = "printerWeaponItem";
	%weapon[%a++] = "pinballLauncherItem";
	%weapon[%a++] = "chainsawItem";
	%weapon[%a++] = "fistItem";
	%weapon[%a++] = "butterflyknifeItem";
	%weapon[%a++] = "airhammerItem";
	%weapon[%a++] = "crowbarItem";
	%weapon[%a++] = "redBaseballBatItem";
	
	//special
	%weapon[%a++] = "pushBroomItem";
	%weapon[%a++] = "PullerRope";
	%weapon[%a++] = "GrappleRope";
	
	//kits
	if($Pref::Server::DeathMatch::RandomisedKits)
	{
		%weapon[%a++] = "blueCloakItem";
		%weapon[%a++] = "growKitItem";
		%weapon[%a++] = "shrinkKitItem";
		%weapon[%a++] = "healthKitItem";
		%weapon[%a++] = "shieldKitItem";
		%weapon[%a++] = "blockheadKitItem";
		%weapon[%a++] = "bouncyKitItem";
	}
	
	return %weapon[getRandom(1, %a)];
}

function DM_GetRandomMeleeWeapon()
{
	%a = 0;
	
	//melee
	%weapon[%a++] = "swordItem";
	%weapon[%a++] = "hammerWeaponItem";
	%weapon[%a++] = "wrenchWeaponItem";
	%weapon[%a++] = "printerWeaponItem";
	%weapon[%a++] = "pinballLauncherItem";
	%weapon[%a++] = "chainsawItem";
	%weapon[%a++] = "fistItem";
	%weapon[%a++] = "butterflyknifeItem";
	%weapon[%a++] = "airhammerItem";
	%weapon[%a++] = "crowbarItem";
	%weapon[%a++] = "redBaseballBatItem";
	
	return %weapon[getRandom(1, %a)];
}

function DM_GetRandomItemFromLoadout()
{
	%a = 0;
	if($DM::Item0 !$= "0")
		%weapon[%a++] = $DM::Item0;
	if($DM::Item1 !$= "0")
		%weapon[%a++] = $DM::Item1;
	if($DM::Item2 !$= "0")
		%weapon[%a++] = $DM::Item2;
	if($DM::Item3 !$= "0")
		%weapon[%a++] = $DM::Item3;
	if($DM::Item4 !$= "0")
		%weapon[%a++] = $DM::Item4;
	if($DM::Item0alt !$= "0")
		%weapon[%a++] = $DM::Item0alt;
	if($DM::Item1alt !$= "0")
		%weapon[%a++] = $DM::Item1alt;
	if($DM::Item2alt !$= "0")
		%weapon[%a++] = $DM::Item2alt;
	if($DM::Item3alt !$= "0")
		%weapon[%a++] = $DM::Item3alt;
	if($DM::Item4alt !$= "0")
		%weapon[%a++] = $DM::Item4alt;
	
	if(%a == 0)
		return 0;
	
	return %weapon[getRandom(1, %a)];
}

function DM_GetRandomPlayertype()
{
	%a = 0;
	%player[%a++] = "PlayerJumpJet";
	%player[%a++] = "PlayerLeapJet";
	%player[%a++] = "PlayerNoJet";
	%player[%a++] = "PlayerSportArmor";
	%player[%a++] = "PlayerQuakeArmor";
	
	%player[%a++] = "PlayerDeathmatchArmor";
	%player[%a++] = "PlayerHalfLifeArmor";
	%player[%a++] = "PlayerSuperjumpArmor";
	%player[%a++] = "PlayerBuffArmor";
	
	return %player[getRandom(1, %a)];
}

function GameConnection::DM_ApplyLoadout(%this, %player)
{
	if($DM::RoundType $= "RANDOM" || $DM::RoundType $= "RANDOMBALANCE" || $DM::RoundType $= "RANDOMMELEE")
	{
		if($DM::RoundType $= "RANDOMBALANCE")
			%randomPlayertype = $DM::PlayertypeRandom;
		else
			%randomPlayertype = DM_GetRandomPlayertype();
		
		%player.changeDataBlock(%randomPlayertype);
		
		if($DM::RoundType $= "RANDOMBALANCE")
		{
			%weapon0 = $DM::Item0Random;
			%weapon1 = $DM::Item1Random;
			%weapon2 = $DM::Item2Random;
		}
		else if($DM::RoundType $= "RANDOMMELEE")
		{
			%weapon0 = DM_GetRandomMeleeWeapon();
			%weapon1 = DM_GetRandomMeleeItem();
			%weapon2 = DM_GetRandomMeleeItem();
		}
		else
		{
			%weapon0 = DM_GetRandomRangedWeapon();
			%weapon1 = DM_GetRandomItem();
			%weapon2 = DM_GetRandomItemFromLoadout();
		}
		
		%weapon0 = %weapon0.getID();
		%weapon1 = %weapon1.getID();
		if(%weapon2 !$= "0")
			%weapon2 = %weapon2.getID();
		
		%weapon3 = 0;
		%weapon4 = 0;
	}
	else
	{
		if($DM::RoundType $= "CLASSIC")
			%player.changeDataBlock(PlayerNoJet);
		
		%weapon0 = $DM::Item0Spawn;
		%weapon1 = $DM::Item1Spawn;
		%weapon2 = $DM::Item2Spawn;
		%weapon3 = $DM::Item3Spawn;
		%weapon4 = $DM::Item4Spawn;
		
		if(%weapon0 !$= "0")
			%weapon0 = %weapon0.getID();
		if(%weapon1 !$= "0")
			%weapon1 = %weapon1.getID();
		if(%weapon2 !$= "0")
			%weapon2 = %weapon2.getID();
		if(%weapon3 !$= "0")
			%weapon3 = %weapon3.getID();
		if(%weapon4 !$= "0")
			%weapon4 = %weapon4.getID();
	}
	
	//clean duplicates
	if(%weapon4 !$= "0")
	{
		if(%weapon4 $= %weapon3)
			%weapon4 = 0;
		else if(%weapon4 $= %weapon2)
			%weapon4 = 0;
		else if(%weapon4 $= %weapon1)
			%weapon4 = 0;
		else if(%weapon4 $= %weapon0)
			%weapon4 = 0;
	}
	
	if(%weapon3 !$= "0")
	{
		if(%weapon3 $= %weapon2)
			%weapon3 = 0;
		else if(%weapon3 $= %weapon1)
			%weapon3 = 0;
		else if(%weapon3 $= %weapon0)
			%weapon3 = 0;
	}
	
	if(%weapon2 !$= "0")
	{
		if(%weapon2 $= %weapon1)
			%weapon2 = 0;
		else if(%weapon2 $= %weapon0)
			%weapon2 = 0;
	}
	
	if(%weapon1 !$= "0")
	{
		if(%weapon1 $= %weapon0)
			%weapon1 = 0;
	}
	
	//shift items up if there's an empty slot
	if(%weapon3 $= "0")
	{
		%weapon3 = %weapon4;
		%weapon4 = 0;
	}
	
	if(%weapon2 $= "0")
	{
		%weapon2 = %weapon3;
		%weapon3 = %weapon4;
		%weapon4 = 0;
	}
	
	if(%weapon1 $= "0")
	{
		%weapon1 = %weapon2;
		%weapon2 = %weapon3;
		%weapon3 = %weapon4;
		%weapon4 = 0;
	}
	
	if(%weapon0 $= "0")
	{
		%weapon0 = %weapon1;
		%weapon1 = %weapon2;
		%weapon2 = %weapon3;
		%weapon3 = %weapon4;
		%weapon4 = 0;
	}
	
	%player.tool[0] = %weapon0;
	messageClient(%this, 'MsgItemPickup', '', 0, %weapon0);
	%player.tool[1] = %weapon1;
	messageClient(%this, 'MsgItemPickup', '', 1, %weapon1);
	%player.tool[2] = %weapon2;
	messageClient(%this, 'MsgItemPickup', '', 2, %weapon2);
	%player.tool[3] = %weapon3;
	messageClient(%this, 'MsgItemPickup', '', 3, %weapon3);
	%player.tool[4] = %weapon4;
	messageClient(%this, 'MsgItemPickup', '', 4, %weapon4);
}