//core files
exec("./maps.cs");
exec("./loadout.cs");
exec("./music.cs");
exec("./rounds.cs");
exec("./teams.cs");
exec("./commands.cs");
exec("./help.cs");
exec("./package.cs");
exec("./debug.cs");
exec("./achievements.cs");
exec("./events.cs");

function DM_Tick(%ticks) //main tick, controls and is manipulated by rounds and the minigame
{
	cancel($DM::Tick);
	$DM::RoundRestarting = false;
	
	if($DefaultMiniGame.numMembers > 0)
	{
		%ticks--;
		%secs = %ticks * 0.1;
		$DM::RoundActive = true;
	}
	else
	{
		if($DM::RoundActive)
		{
			$Pref::Server::DeathMatch::RoundLimit = mFloor($Pref::Server::DeathMatch::RoundLimit);
			if($Pref::Server::DeathMatch::RoundLimit == 0 || $Pref::Server::DeathMatch::RoundLimit < -1)
				$Pref::Server::DeathMatch::RoundLimit = -1;
			
			if($Pref::Server::DeathMatch::RoundLimit != -1)
				$DM::ResetCount = $Pref::Server::DeathMatch::RoundLimit; //trigger a map rotation at round end
			
			%ticks = 0; //force the round to end
		}
	}
	
	if($DM::RoundActive)
	{
		if(%secs == mfloor(%secs))
		{
			if(%secs <= 0)
			{
					echo("Round ending...");
					$DM::RoundRestarting = true;
					
					for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
					{
						%member = $DefaultMinigame.member[%a];
						if(isObject(%member))
						{
							commandToClient(%member, 'bottomPrint', "", 0, true);
							%camera = %member.camera;
							%camera.setFlyMode();
							%camera.mode = "Observer";
							%member.setControlObject(%camera);
							%member.DM_isRockingVote = false;
						}
					}
					
					DM_doRoundEnd();
					SM_StopSong();
					
					if($Pref::Server::DeathMatch::EnableMapVoting > 0)
					{
						if($DM::VoteNextRound)
						{
							$DM::CurrentMap = $DM::VoteMap - 1;
							$DM::BypassTheme = true;
							$DM::BypassSort = true;
							$DM::BypassRandom = true;
							schedule(3000, 0, DM_NextMap);
							return;
						}
						else if($DM::VoteInProgress)
						{
							messageAll('', "\c2The vote ended.");
							echo("The vote ended");
							$DM::VoteInProgress = false;
							$DM::VoteMap = "";
							$DM::VoteNextRound = false;
						}
					}
					
					$DM::RoundActive = false;
					$DefaultMiniGame.scheduleReset();
					return;
			}
			
			if(%secs <= 5)
				centerPrintAll("<font:palatino linotype:64>\c6" @ getTimeString(%secs) @ " remaining!", 3);
			
			$DM:CurrentTime = %secs;
		}

		for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
		{
			%member = $DefaultMinigame.member[%a];
			if(isObject(%member))
				%member.DM_ApplyTeam();
		}
	}
	
	$DM::Tick = schedule(100, 0, DM_Tick, %ticks);
}

function DM_TickAlt() //tick to do other things, runs independently of rounds and the minigame
{
	cancel($DM::TickAlt);
	
	//apply hud to players
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
		{
			%member.setDeathMatchBottomPrintInfo();
			
			%member.deathTick++;
			if(%member.deathTick == 45)
				%member.spawnplayer();
		}
	}
	
	$DM::TickAlt = schedule(100, 0, DM_TickAlt);
}

function gameConnection::setDeathMatchBottomPrintInfo(%this)
{
	if($DM::ResetCount <= 0) //if a map is loading
	{
		//loading message
		%this.DMBottomPrint = "<just:center>";
		%this.DMBottomPrint = %this.DMBottomPrint @ "\c6Loading Map\c3: " @ DM_getMapName($DM::CurrentMap) @ "\c6.";
	}
	else if(!$DM::RoundRestarting) //if the round is not resetting / if its in normal gameplay
	{
		//left
		%this.DMBottomPrint = "<just:left>";
		
		//get team
		if(%this.DMTeam > 0)
			%teamColor = DM_getTeamColorString($DM::teamColor[%this.DMTeam]);
		else
			%teamColor = "\c3";
		
		//health & get datablock
		if(isObject(%this.player))
		{
			%player = %this.player;
			%data = %player.getDatablock();
			%this.maxHealth = %data.maxDamage;
			%this.currHealth = (%data.maxDamage - %player.getDamageLevel()) + %player.DM_HealthShield;
			
			%dataName = "";
			%height = getWord(%player.getscale(), 2);
			%width = getWord(%player.getscale(), 0);
			if(%width > %height)
				%dataName = %dataName @ "\c4: Squished ";
			else if(%width < 1 || %width > 1 || %player.canCloak)
				%dataName = %dataName @ "\c4: ";
			else
				%dataName = %dataName @ %teamColor @ ": ";
			
			if(%width < 1)
				%dataName = %dataName @ "Tiny ";
			else if(%width > 1)
				%dataName = %dataName @ "Large ";
			
			if(%player.canCloak)
				%dataName = %dataName @ "Cloakable ";
			
			if(%data.isTurboSportPlayer)
				%dataName = %dataName @ "Sport Player";
			else
				%dataName = %dataName @ %data.uiName;
			
			%this.dataName = %dataName;
		}
		else
		{
			%this.currHealth = 0;
			%dataName = %this.dataName;
		}
		
		//get max health
		if(%this.maxHealth > 0)
		{
			%this.DMBottomPrint = %this.DMBottomPrint @ "\c6Health";
			
			if(mceil(%this.currHealth) > %this.maxHealth)
				%this.DMBottomPrint = %this.DMBottomPrint @ "\c4: " @ mceil(%this.currHealth) @ "\c6/\c4" @ %this.maxHealth;
			else if(mceil(%this.currHealth) > 90)
				%this.DMBottomPrint = %this.DMBottomPrint @ "<color:33ff00>: " @ mceil(%this.currHealth) @ "\c6/<color:33ff00>" @ %this.maxHealth;
			else if(mceil(%this.currHealth) > 80)
				%this.DMBottomPrint = %this.DMBottomPrint @ "<color:66ff00>: " @ mceil(%this.currHealth) @ "\c6/<color:66ff00>" @ %this.maxHealth;
			else if(mceil(%this.currHealth) > 70)
				%this.DMBottomPrint = %this.DMBottomPrint @ "<color:99ff00>: " @ mceil(%this.currHealth) @ "\c6/<color:99ff00>" @ %this.maxHealth;
			else if(mceil(%this.currHealth) > 60)
				%this.DMBottomPrint = %this.DMBottomPrint @ "<color:ccff00>: " @ mceil(%this.currHealth) @ "\c6/<color:ccff00>" @ %this.maxHealth;
			else if(mceil(%this.currHealth) > 50)
				%this.DMBottomPrint = %this.DMBottomPrint @ "\c3: " @ mceil(%this.currHealth) @ "\c6/\c3" @ %this.maxHealth;
			else if(mceil(%this.currHealth) > 40)
				%this.DMBottomPrint = %this.DMBottomPrint @ "<color:ffcc00>: " @ mceil(%this.currHealth) @ "\c6/<color:ffcc00>" @ %this.maxHealth;
			else if(mceil(%this.currHealth) > 30)
				%this.DMBottomPrint = %this.DMBottomPrint @ "<color:ff9900>: " @ mceil(%this.currHealth) @ "\c6/<color:ff9900>" @ %this.maxHealth;
			else if(mceil(%this.currHealth) > 20)
				%this.DMBottomPrint = %this.DMBottomPrint @ "<color:ff6600>: " @ mceil(%this.currHealth) @ "\c6/<color:ff6600>" @ %this.maxHealth;
			else if(mceil(%this.currHealth) > 10)
				%this.DMBottomPrint = %this.DMBottomPrint @ "<color:ff3300>: " @ mceil(%this.currHealth) @ "\c6/<color:ff3300>" @ %this.maxHealth;
			else
				%this.DMBottomPrint = %this.DMBottomPrint @ "\c0: " @ mceil(%this.currHealth) @ "\c6/\c0" @ %this.maxHealth;
		}
		
		//right
		%this.DMBottomPrint = %this.DMBottomPrint @ "<just:right>";
		
		//round
		if($Pref::Server::DeathMatch::RoundLimit > 0 && $DM::numMaps > 0)
			%this.DMBottomPrint = %this.DMBottomPrint @ " \c6Round" @ %teamColor @ ": " @ $DM::ResetCount @ "/" @ $Pref::Server::DeathMatch::RoundLimit;
		
		//time
		%this.DMBottomPrint = %this.DMBottomPrint @ " \c6Time" @ %teamColor @ ": " @ getTimeString($DM:CurrentTime);
		
		//score
		%this.DMBottomPrint = %this.DMBottomPrint @ " \c6Score" @ %teamColor @ ": " @ mfloor(%this.score);
		
		//new line
		%this.DMBottomPrint = %this.DMBottomPrint @ " <br><just:left>";
		
		//datablock
		if(DM_getRoundTypesAllowed("RANDOM") > 0)
			%this.DMBottomPrint = %this.DMBottomPrint @ "\c6Playertype" @ %dataName;
		
		//right
		%this.DMBottomPrint = %this.DMBottomPrint @ "<just:right>";
		
		//keys
		if(%this.DMHasKey_Red)
			%this.DMBottomPrint = %this.DMBottomPrint @ "\c0KEY ";
		if(%this.DMHasKey_Yellow)
			%this.DMBottomPrint = %this.DMBottomPrint @ "\c3KEY ";
		if(%this.DMHasKey_Green)
			%this.DMBottomPrint = %this.DMBottomPrint @ "\c2KEY ";
		if(%this.DMHasKey_Blue)
			%this.DMBottomPrint = %this.DMBottomPrint @ "\c1KEY ";
		
		//team
		if($DM::TeamRoundType !$= "NONE" && %this.DMTeam > 0)
			%this.DMBottomPrint = %this.DMBottomPrint @ "\c6Team" @ %teamColor @ ": " @ DM_getTeamNameString($DM::teamColor[%this.DMTeam]) @ " ";
	}
	else
		%this.DMBottomPrint = ""; //set it to blank, will clear the bottom print during round transitions
	
	//completed building it, send it.
	commandToClient(%this, 'bottomPrint', %this.DMBottomPrint, 0, true);
}

function gameConnection::DM_SaveData(%this, %string)
{
	if(!isObject(%this))
	{
		error("Tried to mess with save data for unknown client \"" @ %this @ "\"");
		return;
	}
	
	if(mfloor(%this.BL_ID) !$= %this.BL_ID)
	{
		error("Tried to mess with save data for BL_ID \"" @ %this.BL_ID @ "\" which is not a number");
		return;
	}
	
	if(%string $= "SAVE" || %string $= "ROUNDSAVE")
	{
		$DeathMatch_Player[%this.bl_id, "PlayerName"] = %this.getPlayerName();
		
		if(%string $= "ROUNDSAVE")
		{
			if($DM::TeamRoundType !$= "NONE")
			{
				if($DeathMatch_Player[%this.bl_id, "BestTeamScore"] $= "")
					$DeathMatch_Player[%this.bl_id, "BestTeamScore"] = -2000000000;
				if(%this.score > mfloor($DeathMatch_Player[%this.bl_id, "BestTeamScore"]))
					$DeathMatch_Player[%this.bl_id, "BestTeamScore"] = %this.score;
				
				if($DeathMatch_Player[%this.bl_id, "WorstTeamScore"] $= "")
					$DeathMatch_Player[%this.bl_id, "WorstTeamScore"] = 2000000000;
				if(%this.score < mfloor($DeathMatch_Player[%this.bl_id, "WorstTeamScore"]))
					$DeathMatch_Player[%this.bl_id, "WorstTeamScore"] = %this.score;
			}
			else
			{
				if($DeathMatch_Player[%this.bl_id, "BestScore"] $= "")
					$DeathMatch_Player[%this.bl_id, "BestScore"] = -2000000000;
				if(%this.score > mfloor($DeathMatch_Player[%this.bl_id, "BestScore"]))
					$DeathMatch_Player[%this.bl_id, "BestScore"] = %this.score;
				
				if($DeathMatch_Player[%this.bl_id, "WorstScore"] $= "")
					$DeathMatch_Player[%this.bl_id, "WorstScore"] = 2000000000;
				if(%this.score < mfloor($DeathMatch_Player[%this.bl_id, "WorstScore"]))
					$DeathMatch_Player[%this.bl_id, "WorstScore"] = %this.score;
			}
		}
		
		export("$DeathMatch_Player" @ %this.bl_id @ "_*", "config/server/DeathMatch/playersaves/" @ %this.bl_id @ ".cs");
	}
	else
		error("Tried to mess with save data using unknown string \"" @ %string @ "\"");
}