function DM_BuildMapList()
{
	%pattern = "Add-Ons/DeathMatch_*/save.bls";
	
	$DM::numMaps = 0;
	
	%file = findFirstFile(%pattern);
	while(%file !$= "")
	{
		$DM::Map[$DM::numMaps] = %file;
		
		%sort = "";
		%theme = "";
		%configFileLocation = filePath(%file) @ "/config.txt";
		if(isFile(%configFileLocation))
		{
			%configFile = new fileObject();
			%configFile.openForRead(%configFileLocation);

			while(!%configFile.isEOF())
			{
				%line = trim(%configFile.readLine());

				if(%line $= "")
					continue;

				%firstWord = getWord(%line, 0);

				switch$(%firstWord)
				{
					case "sort":
						%sort = getWord(%line, getWordCount(%line)-1);
					case "theme":
						%theme = getWord(%line, getWordCount(%line)-1);
				}
			}
			
			%configFile.close();
			%configFile.delete();
		}
		
		if(%sort !$= "")
		{
			%sort = strReplace(%sort, "_", " ");
			$DM::MapSort[$DM::numMaps] = %sort;
		}
		else
			$DM::MapSort[$DM::numMaps] = "Unsorted";

		if(%theme !$= "")
		{
			%theme = strReplace(%theme, "_", " ");
			$DM::MapTheme[$DM::numMaps] = %theme;
		}
		else
			$DM::MapTheme[$DM::numMaps] = "Themeless";
		
		$DM::numMaps++;
		%file = findNextFile(%pattern);
	}
}

function DM_getMapName(%displayName, %fromPath)
{
	%error = %displayName;
	
	if(!%fromPath)
		%displayName = $DM::Map[%displayName];
	
	%displayName = strReplace(%displayName, "Add-Ons/DeathMatch_", "");
	%displayName = strReplace(%displayName, "/save.bls", "");
	%displayName = strReplace(%displayName, "_", " ");
	
	if(%displayName $= "")
		error(%fromPath @ "Tried to get display name with " @ %error);
	
	return %displayName;
}

function DM_NextMap()
{
	echo("Loading next map...");
	
	if(($Pref::Server::DeathMatch::RandomMaps == true && !$DM::BypassRandom) || $DM::ForceRandom)
	{
		%i = getRandom(1, $DM::numMaps);

		if(%i <= $DM::CurrentMap)
			%i--;
		
		$DM::CurrentMap = %i - 1;
		$DM::ForceRandom = false;
	}
	
	$DM::BypassRandom = false;
	
	if($Pref::Server::DeathMatch::ForceMapCategory !$= "" && !$DM::BypassSort && $Pref::Server::DeathMatch::ForceMapTheme !$= "" && !$DM::BypassTheme)
	{
		for(%a = 0; %a < $DM::numMaps; %a++)
		{
			if($DM::MapSort[%a] $= $Pref::Server::DeathMatch::ForceMapCategory && $DM::MapTheme[%a] $= $Pref::Server::DeathMatch::ForceMapTheme)
			{
				%allExists = true;
				
				if(!%allFoundFirstMap)
				{
					%allFirstToLoad = %a;
					%allFoundFirstMap = true;
				}
				
				if(!%allFoundNextMap)
				{
					%allMapToLoad = %a;
					
					if(%a > $DM::CurrentMap)
						%allFoundNextMap = true;
				}
				
				%allLastToLoad = %a;
			}
		}
		
		if(%allExists)
		{
			if($DM::CurrentMap >= %allLastToLoad && !%allFoundNextMap)
				%allMapToLoad = %allFirstToLoad;
			
			$DM::CurrentMap = %allMapToLoad - 1;
			$DM::BypassSort = false;
			$DM::BypassTheme = false;
		}
		else
		{
			error("ERROR: No maps have category " @ $Pref::Server::DeathMatch::ForceMapCategory @ " AND the " @ $Pref::Server::DeathMatch::ForceMapTheme @ " theme. Setting theme pref to NONE");
			$Pref::Server::DeathMatch::ForceMapTheme = "";
			DM_NextMap();
			return;
		}
	}
	else
	{
		if($Pref::Server::DeathMatch::ForceMapCategory !$= "" && !$DM::BypassSort)
		{
			for(%a = 0; %a < $DM::numMaps; %a++)
			{
				if($DM::MapSort[%a] $= $Pref::Server::DeathMatch::ForceMapCategory)
				{
					%sortExists = true;
					
					if(!%foundFirstMap)
					{
						%firstToLoad = %a;
						%foundFirstMap = true;
					}
					
					if(!%foundNextMap)
					{
						%mapToLoad = %a;
						
						if(%a > $DM::CurrentMap)
							%foundNextMap = true;
					}
					
					%lastToLoad = %a;
				}
			}
			
			if(%sortExists)
			{
				if($DM::CurrentMap >= %lastToLoad && !%foundNextMap)
					%mapToLoad = %firstToLoad;
				
				$DM::CurrentMap = %mapToLoad - 1;
			}
			else
			{
				error("ERROR: No maps are in category " @ $Pref::Server::DeathMatch::ForceMapCategory @ ". Setting sort pref to NONE");
				$Pref::Server::DeathMatch::ForceMapCategory = "";
			}
		}
		
		$DM::BypassSort = false;
		
		if($Pref::Server::DeathMatch::ForceMapTheme !$= "" && !$DM::BypassTheme)
		{
			for(%b = 0; %b < $DM::numMaps; %b++)
			{
				if($DM::MapTheme[%b] $= $Pref::Server::DeathMatch::ForceMapTheme)
				{
					%themeExists = true;
					
					if(!%themeFoundFirstMap)
					{
						%themeFirstToLoad = %b;
						%themeFoundFirstMap = true;
					}
					
					if(!%themeFoundNextMap)
					{
						%themeMapToLoad = %b;
						
						if(%b > $DM::CurrentMap)
							%themeFoundNextMap = true;
					}
					
					%themeLastToLoad = %b;
				}
			}
			
			if(%themeExists)
			{
				if($DM::CurrentMap >= %themeLastToLoad && !%themeFoundNextMap)
					%themeMapToLoad = %themeFirstToLoad;
				
				$DM::CurrentMap = %themeMapToLoad - 1;
			}
			else
			{
				error("ERROR: No maps have the " @ $Pref::Server::DeathMatch::ForceMapTheme @ " theme. Setting theme pref to NONE");
				$Pref::Server::DeathMatch::ForceMapTheme = "";
			}
		}
		
		$DM::BypassTheme = false;
	}
	
	$DM::CurrentMap = mFloor($DM::CurrentMap);
	$DM::CurrentMap++;
	$DM::CurrentMap = $DM::CurrentMap % $DM::numMaps;
	
	cancel($DM::Tick);
	$DM::RoundRestarting = true;
	$DM::VoteInProgress = false;
	$DM::VoteMap = "";
	$DM::VoteNextRound = false;
	SM_StopSong();
	for(%aaa = 0; %aaa < $DefaultMinigame.numMembers; %aaa++)
	{
		%member = $DefaultMinigame.member[%aaa];
		if(isObject(%member))
		{
			commandToClient(%member, 'bottomPrint', "", 0, true);
			%member.DM_isRockingVote = false;
		}
	}
	
	$DM::ResetCount = 0;
	
	DM_LoadMap_Phase1($DM::Map[$DM::CurrentMap]);
}

function DM_LoadMap_Phase1(%filename)
{
	//suspend minigame resets
	$DM::MapChange = 1;

	//put everyone in observer mode
	%mg = $DefaultMiniGame;
	if(!isObject(%mg))
	{
		error("ERROR: DM_LoadMap_Phase1(" @ %filename  @ ") - default minigame does not exist");
		return;
	}
	for(%i = 0; %i < %mg.numMembers; %i++)
	{
		%client = %mg.member[%i];
		%player = %client.player;
		if(isObject(%player))
			%player.delete();

		%camera = %client.camera;
		%camera.setFlyMode();
		%camera.mode = "Observer";
		%client.setControlObject(%camera);
	}
	
	//clear all bricks 
	// note: this function is deferred, so we'll have to set a callback to be triggered when it's done
	BrickGroup_888888.chaindeletecallback = "DM_LoadMap_Phase2(\"" @ %filename @ "\");";
	BrickGroup_888888.chaindeleteall();
}

function DM_LoadMap_Phase2(%filename)
{
	echo("Loading deathmatch map from " @ %filename);
	%loadMsg = "\c5Now loading " @ $DM::MapTheme[$DM::CurrentMap] SPC $DM::MapSort[$DM::CurrentMap] @ " map \c6" @ DM_getMapName(%filename, 1);
	
	//load config file
	$DM::Item0 = 0;
	$DM::Item1 = 0;
	$DM::Item2 = 0;
	$DM::Item3 = 0;
	$DM::Item4 = 0;
	$DM::Item0alt = 0;
	$DM::Item1alt = 0;
	$DM::Item2alt = 0;
	$DM::Item3alt = 0;
	$DM::Item4alt = 0;
	$DM::BrickDamage = 0;
	$DM::MapMusic = "";
	$DM::MapMusicAll = 0;
	$DM::killWater = 0;
	$DM::allowAltLoadout = 0;
	$DM::mapTeam1 = "RED";
	$DM::mapTeam2 = "BLUE";
	$DM::mapTeam3 = "YELLOW";
	$DM::mapTeam4 = "GREEN";
	$DM::force2teams = 0;
	$DM::force4teams = 0;
	$DM::mapCredits = "NONE";
	$DM::mapDescription = "NONE";
	$DM::mapEnvironment = 0;
	$DM::mapFile = %fileName;
	
	%configFilename = filePath(%fileName) @ "/config.txt";
	if(isFile(%configFilename))
	{
		%file = new fileObject();
		%file.openForRead(%configFilename);
		echo(" +- has config file");
		
		while(!%file.isEOF())
		{
			%line = trim(%file.readLine());

			if(%line $= "")
				continue;

			%firstWord = getWord(%line, 0);

			switch$(%firstWord)
			{
				case "item0":
					%item0 = getWord(%line, getWordCount(%line) - 1);
				case "item1":
					%item1 = getWord(%line, getWordCount(%line) - 1);
				case "item2":
					%item2 = getWord(%line, getWordCount(%line) - 1);
				case "item3":
					%item3 = getWord(%line, getWordCount(%line) - 1);
				case "item4":
					%item4 = getWord(%line, getWordCount(%line) - 1);
				case "item0alt":
					%item0alt = getWord(%line, getWordCount(%line) - 1);
				case "item1alt":
					%item1alt = getWord(%line, getWordCount(%line) - 1);
				case "item2alt":
					%item2alt = getWord(%line, getWordCount(%line) - 1);
				case "item3alt":
					%item3alt = getWord(%line, getWordCount(%line) - 1);
				case "item4alt":
					%item4alt = getWord(%line, getWordCount(%line) - 1);
				case "brickDamage":
					%brickDamage = getWord(%line, getWordCount(%line) - 1);
				case "music":
					%musicMain = getWord(%line, getWordCount(%line) - 1);
				case "musicAll":
					%musicAll = getWord(%line, getWordCount(%line) - 1);
				case "killWater":
					%killWater = getWord(%line, getWordCount(%line) - 1);
				case "allowAltLoadout":
					%allowAltLoadout = getWord(%line, getWordCount(%line) - 1);
				case "teamColor1":
					%teamColor1 = getWord(%line, getWordCount(%line) - 1);
				case "teamColor2":
					%teamColor2 = getWord(%line, getWordCount(%line) - 1);
				case "teamColor3":
					%teamColor3 = getWord(%line, getWordCount(%line) - 1);
				case "teamColor4":
					%teamColor4 = getWord(%line, getWordCount(%line) - 1);
				case "force2teams":
					%force2teams = getWord(%line, getWordCount(%line) - 1);
				case "force4teams":
					%force4teams = getWord(%line, getWordCount(%line) - 1);
			}
		}

		if(%item0 !$= "")
			$DM::Item0 = DM_ConvertOldItem(%item0);
		if(%item1 !$= "")
			$DM::Item1 = DM_ConvertOldItem(%item1);
		if(%item2 !$= "")
			$DM::Item2 = DM_ConvertOldItem(%item2);
		if(%item3 !$= "")
			$DM::Item3 = DM_ConvertOldItem(%item3);
		if(%item4 !$= "")
			$DM::Item4 = DM_ConvertOldItem(%item4);
		if(%item0alt !$= "")
			$DM::Item0alt = DM_ConvertOldItem(%item0alt);
		if(%item1alt !$= "")
			$DM::Item1alt = DM_ConvertOldItem(%item1alt);
		if(%item2alt !$= "")
			$DM::Item2alt = DM_ConvertOldItem(%item2alt);
		if(%item3alt !$= "")
			$DM::Item3alt = DM_ConvertOldItem(%item3alt);
		if(%item4alt !$= "")
			$DM::Item4alt = DM_ConvertOldItem(%item4alt);
		if(%allowAltLoadout $= "true" || mfloor(%allowAltLoadout) >= 1)
			$DM::allowAltLoadout = 1;
		
		if(%brickDamage $= "true" || mfloor(%brickDamage) >= 1)
			$DM::BrickDamage = 1;
		
		if(%musicMain !$= "")
		{
			$DM::MapMusic = %musicMain;
			
			if(%musicAll $= "true" || mfloor(%musicAll) >= 1)
				$DM::MapMusicAll = 1;
		}
		
		if(%killWater $= "true" || mfloor(%killWater) >= 1)
			$DM::killWater = 1;
		
		if(!DM_isValidTeam(%teamColor1))
			$DM::mapTeam1 = "RED";
		else
			$DM::mapTeam1 = %teamColor1;
		if(!DM_isValidTeam(%teamColor2))
			$DM::mapTeam2 = "BLUE";
		else
			$DM::mapTeam2 = %teamColor2;
		if(!DM_isValidTeam(%teamColor3))
			$DM::mapTeam3 = "YELLOW";
		else
			$DM::mapTeam3 = %teamColor3;
		if(!DM_isValidTeam(%teamColor4))
			$DM::mapTeam4 = "GREEN";
		else
			$DM::mapTeam4 = %teamColor4;
		if($DM::mapTeam1 $= $DM::mapTeam2 ||
		   $DM::mapTeam1 $= $DM::mapTeam3 ||
		   $DM::mapTeam1 $= $DM::mapTeam4 ||
		   $DM::mapTeam2 $= $DM::mapTeam3 ||
		   $DM::mapTeam2 $= $DM::mapTeam4 ||
		   $DM::mapTeam3 $= $DM::mapTeam4)
		{
			$DM::mapTeam1 = "RED";
			$DM::mapTeam2 = "BLUE";
			$DM::mapTeam3 = "YELLOW";
			$DM::mapTeam4 = "GREEN";
		}
		
		if(%force2teams $= "true" || mfloor(%force2teams) >= 1)
			$DM::force2teams = 1;
		if(%force4teams $= "true" || mfloor(%force4teams) >= 1)
			$DM::force4teams = 1;
		
		%file.close();
		%file.delete();
	}
	else
		echo(" +- no config file");
	
	//read and display credits file, if it exists
	// limited to one line
	%creditsFilename = filePath(%fileName) @ "/credits.txt";
	if(isFile(%creditsFilename))
	{
		%file = new FileObject();
		%file.openforRead(%creditsFilename);

		%line = %file.readLine();
		%line = stripMLControlChars(%line);
		if(%line !$= "")
		{
			echo(" +- has credits file");
			%loadMsg = %loadMsg @ "\c5, created by \c3" @ %line;
			$DM::mapCredits = "\c5Created by \c3" @ %line;
		}
		else
			echo(" +- has credits file, but it's blank");

		%file.close();
		%file.delete();
	}
	else
		echo(" +- no credits file");
	messageAll('', %loadMsg @ "\c5.");
	//messageAll('', "\c5This map is \c6" @ $DM::MapTheme[$DM::CurrentMap] @ " \c5themed, and is categorised under \c3" @ $DM::MapSort[$DM::CurrentMap] @ "\c5.");
	
	//read and display description file, if it exists
	// limited to one line
	//blockland glass forces descriptions to be in addons, sigh
	%descriptionFilename = filePath(%fileName) @ "/description.txt";
	if(isFile(%descriptionFilename))
	{
		%file = new FileObject();
		%file.openforRead(%descriptionFilename);

		%line = %file.readLine();
		%line = stripMLControlChars(%line);
		if(%line !$= "")
		{
			echo(" +- has description file");
			%descMsg = %descMsg @ "\c5" @ %line;
			$DM::mapDescription = "\c5" @ %line;
		}
		else
			echo(" +- has description file, but it's blank");

		%file.close();
		%file.delete();
	}
	else
		echo(" +- no description file");
	messageAll('', %descMsg);
	
	//load environment if it exists
	%envFile = filePath(%fileName) @ "/environment.txt"; 
	if(isFile(%envFile))
	{
		//echo("parsing env file " @ %envFile);
		//usage: GameModeGuiServer::ParseGameModeFile(%filename, %append);
		//if %append == 0, all minigame variables will be cleared 
		%res = GameModeGuiServer::ParseGameModeFile(%envFile, 1);
		echo(" +- has environment file");

		EnvGuiServer::getIdxFromFilenames();
		EnvGuiServer::SetSimpleMode();
		$DM::mapEnvironment = 1;
		
		if(!$EnvGuiServer::SimpleMode)
		{
			EnvGuiServer::fillAdvancedVarsFromSimple();
			EnvGuiServer::SetAdvancedMode();
		}
	}
	else
		echo(" +- no environment file");
	
	if(!isObject(DM_FakeClient))
		new GameConnection(DM_FakeClient);
	
	DM_FakeClient.isAdmin = 1;
	DM_FakeClient.isSuperAdmin = 1;
	DM_FakeClient.minigame = $DefaultMinigame;
	
	if($DM::killWater)
		serverCmdEnvGui_SetVar(DM_FakeClient, "WaterHeight", 5);
	
	serverCmdSetMiniGameData(DM_FakeClient, "BD" SPC $DM::BrickDamage);
	
	//set fake name tables so old items are replaced with current ones
	DM_AddFakeNameTables();
	
	//load save file
	schedule(10, 0, serverDirectSaveFileLoad, %fileName, 3, "", 2, 1);
}