function DM_DetermineRoundType()
{
	if(DM_getRoundTypesAllowed() == 0)
		$Pref::Server::DeathMatch::ArcadeRounds = true;
	
	$DM::RoundName = "";
	$DM::RoundDesc = "";
	
	//determine what team round type it is
	if(DM_getRoundTypesAllowed() > 1)
	{
		%isTeamRound = 0;
		if($Pref::Server::DeathMatch::TeamRounds == 2)
			%isTeamRound = 1;
		else if($DefaultMiniGame.numMembers > 2)
			%isTeamRound = getRandom(0, 1);
		
		%teamRandom = 0;
		if($DM::force4teams)
			%teamRandom = 1;
		else if($DM::force2teams)
			%teamRandom = 0;
		else if($DefaultMiniGame.numMembers > 4)
			%teamRandom = getRandom(0, 1);
		
		//apply the team round
		if(!%isTeamRound)
			$DM::TeamRoundType = "NONE";
		else if(%teamRandom == 0)
			$DM::TeamRoundType = "TEAMS";
		else if(%teamRandom == 1)
			$DM::TeamRoundType = "4TEAMS";
	}
	else
	{
		$DM::TeamRoundType = "NONE";
		if($Pref::Server::DeathMatch::TeamRounds == 2)
		{
			$DM::TeamRoundType = "TEAMS";
			if($DM::force4teams)
				$DM::TeamRoundType = "4TEAMS";
		}
	}
	
	//catch what the previous round was
	if($DM::RoundType $= "RANDOMMELEE")
		%wasMelee = 1;
	
	//determine what the randomiser can pick
	%random = getRandom(0, (DM_getRoundTypesAllowed() - 1) - %wasMelee);
	
	%types = -1;
	if($Pref::Server::DeathMatch::ArcadeRounds)
		%round[%types++] = 0;
	if($Pref::Server::DeathMatch::ClassicRounds)
		%round[%types++] = 1;
	if($Pref::Server::DeathMatch::RandomisedRounds)
		%round[%types++] = 2;
	if($Pref::Server::DeathMatch::RandomBalanceRounds)
		%round[%types++] = 3;
	if($Pref::Server::DeathMatch::RandomMeleeRounds)
		%round[%types++] = 4;
	
	//apply the round type
	if(%round[%random] == 0)
		$DM::RoundType = "ARCADE";
	else if(%round[%random] == 1)
		$DM::RoundType = "CLASSIC";
	else if(%round[%random] == 2)
		$DM::RoundType = "RANDOM";
	else if(%round[%random] == 3)
		$DM::RoundType = "RANDOMBALANCE";
	else if(%round[%random] == 4)
		$DM::RoundType = "RANDOMMELEE";
	
	//we build the round name and description starting from here
	if($DM::TeamRoundType $= "4TEAMS")
		$DM::RoundName = $DM::RoundName @ "4 Team ";
	
	if($DM::RoundType $= "ARCADE")
	{
		$DM::RoundName = $DM::RoundName @ "Arcade";
		if(!$Pref::Server::DeathMatch::CrouchJump)
			$DM::RoundDesc = $DM::RoundDesc @ "Fast speed!";
		else
			$DM::RoundDesc = $DM::RoundDesc @ "Fast speed and crouch jumping!";
	}
	else if($DM::RoundType $= "CLASSIC")
	{
		$DM::RoundName = $DM::RoundName @ "Classic";
		$DM::RoundDesc = $DM::RoundDesc @ "Default playertype!";
	}
	else if($DM::RoundType $= "RANDOM")
	{
		$DM::RoundName = $DM::RoundName @ "Randomised";
		$DM::RoundDesc = $DM::RoundDesc @ "Everyone is randomised!";
	}
	else if($DM::RoundType $= "RANDOMBALANCE")
	{
		$DM::RoundName = $DM::RoundName @ "Random Balance";
		$DM::RoundDesc = $DM::RoundDesc @ "Everyone is randomised in exactly the same way!";
	}
	else if($DM::RoundType $= "RANDOMMELEE")
	{
		$DM::RoundName = $DM::RoundName @ "Random Melee";
		$DM::RoundDesc = $DM::RoundDesc @ "Everyone is randomised with only melee items!";
	}
	
	if($DM::TeamRoundType $= "TEAMS")
		$DM::RoundName = $DM::RoundName @ " Teams";
}

function DM_PrepareRound()
{
	$DM::teamColor1 = 0;
	$DM::teamColor2 = 0;
	$DM::teamColor3 = 0;
	$DM::teamColor4 = 0;
	$DM::TeamScore1 = 0;
	$DM::TeamScore2 = 0;
	$DM::TeamScore3 = 0;
	$DM::TeamScore4 = 0;
	$DM::TeamPlayers1 = 0;
	$DM::TeamPlayers2 = 0;
	$DM::TeamPlayers3 = 0;
	$DM::TeamPlayers4 = 0;
	
	$DM::teamColor1 = $DM::mapTeam1;
	$DM::teamColor2 = $DM::mapTeam2;
	$DM::teamColor3 = $DM::mapTeam3;
	$DM::teamColor4 = $DM::mapTeam4;
	
	if($Pref::Server::DeathMatch::RandomTeamColors > 0)
	{
		%team1 = $DM::mapTeam1;
		%team2 = $DM::mapTeam2;
		%team3 = $DM::mapTeam3;
		%team4 = $DM::mapTeam4;
		
		if(getRandom(1, $Pref::Server::DeathMatch::RandomTeamColors) == 1)
			%team1 = DM_getRandomTeam(DM_teamColorToNumber(%team2), DM_teamColorToNumber(%team3), DM_teamColorToNumber(%team4));
		if(getRandom(1, $Pref::Server::DeathMatch::RandomTeamColors) == 1)
			%team2 = DM_getRandomTeam(DM_teamColorToNumber(%team1), DM_teamColorToNumber(%team3), DM_teamColorToNumber(%team4));
		if(getRandom(1, $Pref::Server::DeathMatch::RandomTeamColors) == 1)
			%team3 = DM_getRandomTeam(DM_teamColorToNumber(%team1), DM_teamColorToNumber(%team2), DM_teamColorToNumber(%team4));
		if(getRandom(1, $Pref::Server::DeathMatch::RandomTeamColors) == 1)
			%team4 = DM_getRandomTeam(DM_teamColorToNumber(%team1), DM_teamColorToNumber(%team2), DM_teamColorToNumber(%team3));
		
		if(%team1 $= %team2 ||
		   %team1 $= %team3 ||
		   %team1 $= %team4 ||
		   %team2 $= %team3 ||
		   %team2 $= %team4 ||
		   %team3 $= %team4)
		{
			%team1 = "RED";
			%team2 = "BLUE";
			%team3 = "YELLOW";
			%team4 = "GREEN";
		}
		
		$DM::teamColor1 = %team1;
		$DM::teamColor2 = %team2;
		$DM::teamColor3 = %team3;
		$DM::teamColor4 = %team4;
	}
	else if($Pref::Server::DeathMatch::RandomTeamColors != -1)
		$Pref::Server::DeathMatch::RandomTeamColors = -1;
	
	if($DM::RoundType $= "RANDOMBALANCE")
	{
		$DM::Item0Random = DM_GetRandomWeapon();
		$DM::Item1Random = DM_GetRandomItem();
		$DM::Item2Random = DM_GetRandomItemFromLoadout();
		$DM::PlayertypeRandom = DM_GetRandomPlayertype();
	}
	else
	{
		$DM::Item0Spawn = $DM::Item0;
		$DM::Item1Spawn = $DM::Item1;
		$DM::Item2Spawn = $DM::Item2;
		$DM::Item3Spawn = $DM::Item3;
		$DM::Item4Spawn = $DM::Item4;
		if($DM::allowAltLoadout)
		{
			if(getRandom(0, 1) == 1)
				$DM::Item0Spawn = $DM::Item0alt;
			if(getRandom(0, 1) == 1)
				$DM::Item1Spawn = $DM::Item1alt;
			if(getRandom(0, 1) == 1)
				$DM::Item2Spawn = $DM::Item2alt;
			if(getRandom(0, 1) == 1)
				$DM::Item3Spawn = $DM::Item3alt;
			if(getRandom(0, 1) == 1)
				$DM::Item4Spawn = $DM::Item4alt;
		}
	}
	
	//clean duplicates
	if($DM::Item4Spawn !$= "0")
	{
		if($DM::Item4Spawn $= $DM::Item3Spawn)
			$DM::Item4Spawn = 0;
		else if($DM::Item4Spawn $= $DM::Item2Spawn)
			$DM::Item4Spawn = 0;
		else if($DM::Item4Spawn $= $DM::Item1Spawn)
			$DM::Item4Spawn = 0;
		else if($DM::Item4Spawn $= $DM::Item0Spawn)
			$DM::Item4Spawn = 0;
	}
	
	if($DM::Item3Spawn !$= "0")
	{
		if($DM::Item3Spawn $= $DM::Item2Spawn)
			$DM::Item3Spawn = 0;
		else if($DM::Item3Spawn $= $DM::Item1Spawn)
			$DM::Item3Spawn = 0;
		else if($DM::Item3Spawn $= $DM::Item0Spawn)
			$DM::Item3Spawn = 0;
	}
	
	if($DM::Item2Spawn !$= "0")
	{
		if($DM::Item2Spawn $= $DM::Item1Spawn)
			$DM::Item2Spawn = 0;
		else if($DM::Item2Spawn $= $DM::Item0Spawn)
			$DM::Item2Spawn = 0;
	}
	
	if($DM::Item1Spawn !$= "0")
	{
		if($DM::Item1Spawn $= $DM::Item0Spawn)
			$DM::Item1Spawn = 0;
	}
	
	//shift items up if there's an empty slot
	if($DM::Item3Spawn $= "0")
	{
		$DM::Item3Spawn = $DM::Item4Spawn;
		$DM::Item4Spawn = 0;
	}
	
	if($DM::Item2Spawn $= "0")
	{
		$DM::Item2Spawn = $DM::Item3Spawn;
		$DM::Item3Spawn = $DM::Item4Spawn;
		$DM::Item4Spawn = 0;
	}
	
	if($DM::Item1Spawn $= "0")
	{
		$DM::Item1Spawn = $DM::Item2Spawn;
		$DM::Item2Spawn = $DM::Item3Spawn;
		$DM::Item3Spawn = $DM::Item4Spawn;
		$DM::Item4Spawn = 0;
	}
	
	if($DM::Item0Spawn $= "0")
	{
		$DM::Item0Spawn = $DM::Item1Spawn;
		$DM::Item1Spawn = $DM::Item2Spawn;
		$DM::Item2Spawn = $DM::Item3Spawn;
		$DM::Item3Spawn = $DM::Item4Spawn;
		$DM::Item4Spawn = 0;
	}
	
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
		{
			//reset killstreak stuff
			KillStreakDeathMsg(%member,%member.kills,13,0,%Killer);
			%member.kills = 0;
			%member.MultiKills = 0;
			cancel(%member.KillStrkMsgSched);
			%member.KsMsg = 0;
			
			//reset key stuff
			%member.DMHasKey_Red = false;
			%member.DMHasKey_Yellow = false;
			%member.DMHasKey_Green = false;
			%member.DMHasKey_Blue = false;
			
			//reset other stuff
			%member.DMTeam = 0;
			%member.DMWinner = false;
			%member.DM_ApplyTeam();
		}
	}
}

function DM_doRoundEnd()
{
	%winningScore = -2000000000;
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
		{
			if(%member.score > %winningScore)
			{
				%winningClients = 1;
				%winningScore = %member.score;
				if($DM::TeamRoundType $= "NONE")
					%winningNames = "\c3" @ %member.getPlayerName();
				else
					%winningNames = DM_getTeamColorString($DM::teamColor[%member.DMTeam]) @ %member.getPlayerName();
				%winningLast = "";
			}
			else if(%member.score == %winningScore)
			{
				%winningClients++;
				if(%winningLast !$= "")
					%winningNames = %winningNames @ "\c2, " @ %winningLast;
				
				if($DM::TeamRoundType $= "NONE")
					%winningLast = "\c3" @ %member.getPlayerName();
				else
					%winningLast = DM_getTeamColorString($DM::teamColor[%member.DMTeam]) @ %member.getPlayerName();
			}
		}
	}
	
	for(%b = 0; %b < $DefaultMinigame.numMembers; %b++)
	{
		%winMember = $DefaultMinigame.member[%b];
		if(isObject(%winMember))
		{
			if(%winMember.score >= %winningScore)
			{
				if($DM::TeamRoundType $= "NONE")
					$DeathMatch_Player[%winMember.bl_id, "Wins"]++;
				else
					$DeathMatch_Player[%winMember.bl_id, "TeamWins"]++;
				%winMember.DMWinner = true;
				centerPrint(%winMember, "<font:palatino linotype:64>\c3Victory!", 7);
			}
			else
			{
				if($DM::TeamRoundType $= "NONE")
					$DeathMatch_Player[%winMember.bl_id, "Loses"]++;
				else
					$DeathMatch_Player[%winMember.bl_id, "TeamLoses"]++;
				centerPrint(%winMember, "", 7);
			}
			
			%winMember.DM_SaveData("ROUNDSAVE");
		}
	}
	
	if(%winningClients < 1)
	{
		messageAll('', "\c2Nobody won this round.");
		echo("Nobody won the round");
	}
	else if(%winningClients == 1)
	{
		messageAll('', %winningNames @ "\c2 won this round with \c3" @ %winningScore @ "\c2 points.");
		echo(stripMLControlChars(%winningNames) @ " won the round with " @ %winningScore @ " points");
	}
	else if(%winningClients > 1)
	{
		messageAll('', %winningNames @ "\c2, and " @ %winningLast @ "\c2 all won this round with \c3" @ %winningScore @ "\c2 points.");
		echo(stripMLControlChars(%winningNames) @ ", and " @ stripMLControlChars(%winningLast) @ " won the round with " @ %winningScore @ " points");
	}
}

function DM_getRoundTypesAllowed(%type)
{
	if(%type $= "RANDOM")
		%types = $Pref::Server::DeathMatch::RandomisedRounds + $Pref::Server::DeathMatch::RandomBalanceRounds + $Pref::Server::DeathMatch::RandomMeleeRounds;
	else if(%type $= "NORANDOM")
		%types = $Pref::Server::DeathMatch::ArcadeRounds + $Pref::Server::DeathMatch::ClassicRounds;
	else
		%types = $Pref::Server::DeathMatch::ArcadeRounds + $Pref::Server::DeathMatch::ClassicRounds + $Pref::Server::DeathMatch::RandomisedRounds + $Pref::Server::DeathMatch::RandomBalanceRounds + $Pref::Server::DeathMatch::RandomMeleeRounds;
	
	return %types;
}