package crouchJumpPackage
{
	function armor::onTrigger(%this, %obj, %trigger, %val)
	{
		parent::onTrigger(%this, %obj, %trigger, %val);
		
		if(!$Pref::Server::DeathMatch::CrouchJump)
			return;
		
		%height = mfloor(%obj.getDatablock().crouchJummp_heightInPlates);
		
		if(%trigger == 3 &&
		   %obj.scale $= "1 1 1" &&
		   %val == 1) //check if the trigger was a crouch - only works with default scale - only happens at start of crouch
		{
			if(%obj.crouchJump_isCrouchingInAir == false)
			{
				if(%obj.crouchJump_checkInAir()) //if they are in the air then they are crouching in the air.
				{
					%obj.crouchJump_isCrouchingInAir = true;
					%obj.setTransform(vectorAdd(%obj.getPosition(), "0 0" SPC ((%height * 0.2) - 0.05)));
					schedule(100, 0, crouchJump_tick, %obj, 0);
				}
			}
		}
		
		return;
	}
};
activatePackage(crouchJumpPackage);

function Player::crouchJump_checkInAir(%this)
{
	if(!isObject(%this))
		return;
	
	%pos = %this.getPosition();
	%mask = $TypeMasks::FxBrickObjectType | $TypeMasks::StaticObjectType;

	//ground plane check
	if(getWord(%pos, 2) < 0.1 && getWord(%pos, 2) > -0.1) //adding a > check just in case someone decided to delete the floor - it'll be barely noticable now
		return false;
	
	initContainerBoxSearch(vectorAdd(%pos, "0 0 0.8"), "1.25 1.25 3", %mask); //also checks if there's anything above the player so we have better luck at not allowing the player to duck through ceilings - may disallow players to crouch jump if their head is right at the ceiling
	
	%obj = containerSearchNext();
	if(isObject(%obj) && %obj != SunLight.getId() && %obj != %this.getId())
	{
		if(%obj.getClassName() $= "fxDTSBrick" && !%obj.isColliding())
			return true;
		
		return false;
	}
	
	return true;
}

function crouchJump_tick(%player, %num)
{
	if(!isObject(%player))
		return;
	
	if(%num < 500 && %player.crouchJump_isCrouchingInAir == true) //its just going to stop checking after a bit - dont think i should keep this going forever
	{
		if(%player.crouchJump_checkInAir())
		{
			%time = mfloor($Pref::Server::DeathMatch::CrouchJumpTick);
			
			if(%time > 200)
				$Pref::Server::DeathMatch::CrouchJumpTick = 200;
			else if(%time < 1)
				$Pref::Server::DeathMatch::CrouchJumpTick = 1;
			
			%time = $Pref::Server::DeathMatch::CrouchJumpTick;
			
			schedule(%time, 0, crouchJump_tick, %player, %num++);
			return;
		}
		else
			%player.crouchJump_isCrouchingInAir = false;
	}
	else
		%player.crouchJump_isCrouchingInAir = false;
}